/*
header.c

matrix manipulation library
version 0.05
Peter A. Cejchan, GPL
Mon Jul 31 12:24:25 MET 2006
<cej@gli.cas.cz | pac7@post.cz>

header reading functions

*/


#include <u.h>
#include <libc.h>
#include <bio.h>
//#include <ctype.h>
#include "libmatrix.h" 
#include "header.h" 

int 
mat_readheader(int *rows, int *cols)
// reads #rows #columns
{
	char *buf, *av[MAXCOLS], first;
	int n;

	n=0;
	while(n==0){
		if((buf = Brdstr(&bin, '\n', 1)) == nil) return 0;			// nothing to read
		first=buf[0];
//				print("first==%c\n", first);
		n=tokenize(buf, av, 2);
		if(n!=0){
			// skip comment lines
			if((first=='#') || (first=='>')){
//				print("comments\n");
				n=0;
			}
		}
		else{
		// skip whitespace lines
//			print("whitespace\n");	
		}
	}	// ends up with n > 0
	*rows=atoi(av[0]);
	*cols=atoi(av[1]);


	return 1;
}

int 
vec_readheader(int *cols)
// reads #columns
{
	char *buf, *av[MAXCOLS], first;
	int n;

	n=0;
	while(n==0){
		if((buf = Brdstr(&bin, '\n', 1)) == nil) return 0;			// nothing to read
		first=buf[0];
//				print("first==%c\n", first);
		n=tokenize(buf, av, 1); // reads #columns
		if(n!=0){
			// skip comment lines
			if((first=='#') || (first=='>')){
//				print("comments\n");
				n=0;
			}
		}
		else{
		// skip whitespace lines
//			print("whitespace\n");	
		}
	}	// ends up with n > 0
	*cols=atoi(av[0]);
	return 1;
}

