/*
imatrix.h

matrix manipulation library
version 0.05
Peter A. Cejchan, GPL
Mon Jul 31 12:24:25 MET 2006
<cej@gli.cas.cz | pac7@post.cz>

int and bool matrix structure and functions

*/

// structures

struct iMatrix{
	int rows, cols;
	int **x;
};



// functions

iMatrix *imat_alloc(int rows, int cols); 	// allocates memory for a matrix
int imat_read(iMatrix *M);			// reads in a whitespace and newline separated matrix
int tagged_imat_read(iMatrix *M);	// reads in a tagged matrix
int tagged_boolmat_read(iMatrix *M);	// reads in a tagged matrix
int line_tagged_boolmat_read(iMatrix *M);	// reads in a tagged matrix in line-only-once format
void  imat_write(iMatrix *M);		//writes out a matrix 
int  imat_max(iMatrix *M);			//prints out row and col index of first occurrence of max value
int  sq_imat_transpose(iMatrix *M);		// square matrix transposition
iMatrix *imat_transpose(iMatrix *M);		// matrix transposition
void  imat_ident(iMatrix *M);					// store identity matrix in mat
void  imat_add(iMatrix *a, iMatrix *b, iMatrix *out);		// matrix addition
void  imat_sub(iMatrix *a, iMatrix *b, iMatrix *out);		// matrix subtraction
void  imat_mult(iMatrix *a, iMatrix *b, iMatrix *out);	// matrix multiplication
