/*
matrix.h

matrix manipulation library
version 0.05
Peter A. Cejchan, GPL
Mon Jul 31 12:24:25 MET 2006
<cej@gli.cas.cz | pac7@post.cz>

float matrix structure and functions

*/

// structures
struct Matrix{
	int rows, cols;
	double **x;
//	void *where;
};


// functions

int  mat_readheader(int *rows, int *cols);		// reads #rows #columns
Matrix *  mat_alloc(int rows, int cols);		// allocates memory for a matrix
int mat_read(Matrix *mat);				// reads in a whitespace and newline separated matrix
int mat_max(Matrix *mat);		//prints out row and col index of first occurrence of max value
int  sq_mat_transpose(Matrix *mat);			// square matrix transposition
Matrix *  mat_transpose(Matrix *mat);			// matrix transposition
void  mat_ident(Matrix *mat);				// store identity matrix in mat
void  mat_add(Matrix *a, Matrix *b, Matrix *out);		// matrix addition
void  mat_sub(Matrix *a, Matrix *b, Matrix *out);		// matrix subtraction
void  mat_mult(Matrix *a, Matrix *b, Matrix *out);		// matrix multiplication
