/*
svector.c

matrix manipulation library
version 0.05
Peter A. Cejchan, GPL
Mon Jul 31 12:24:25 MET 2006
<cej@gli.cas.cz | pac7@post.cz>

string vector structures and functions

*/


#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>
#include "libmatrix.h" 
#include "svector.h" 

// functions:


sVector *
svec_alloc(int len){
// allocates memory for an int vector

	int i;
	iVector *V;

	V=(iVector*)malloc(sizeof(iVector));
	V->len=len; 
	V->x=(int*)malloc(V->len*sizeof(char [MAXLINELENGTH]));
	for(i=0;i<V->len;i++)
		V->x[i]="";
	return V;
}

/*** old version ***
int 
svec_read(iVector *V)
// read whitespace-delimited vector
{
	char *buf, *av[MAXLENGTH];
	int i, j;

	i=0;
	if((buf = Brdstr(&bin, '\n', 1)) != nil){
		V->len=   tokenize(buf, av, MAXLENGTH);
		for(j=0; j<V->len; j++){
			V->x[j]=atoi(av[j]);
		}
		free(buf);
	}
	return 1;
}
*/

int
svec_read(iVector *V)
// reads in a newline separated vector of strings
{
	char *buf, *av[MAXCOLS];
	int i, j, n;
	for(i=0; i<V->len; i++){
		if((buf = Brdstr(&bin, '\n', 1)) != nil){	
			// skip comment lines
			while((buf[0]=='#') || (buf[0]=='>')){

//				print("comments\n");	
				if((buf = Brdstr(&bin, '\n', 1)) == nil) return 0;	// read another line
			}	
			n=tokenize(buf, av, V->len);
			// skip whitespace lines
			while(n==0){
				print("whitespace\n");	
//				if((buf = Brdstr(&bin, '\n', 1)) == nil) return 0;	// read another line
				n=tokenize(buf, av, V->len);
			}	
			V->x[i]=av[i];
			free(buf);
		}
		else return 0;
	}
	return 1;
}

void 
svec_write(iVector *V)
// write out a vector
{
	int i;
	print("%d ", V->len);
	for(i=0; i<V->len; i++){
		print("%s ", V->x[i]);
	}
	print("\n");
	return;
}


